
// #name = EgoAmmo
// #version = 1.0
// #status = release
// #author = Ego
// #warrior = -Ego-
// #category = EgoScripts
// #description = includes info on grenades and health kit in a revised ammo hud - hudmover compatible
// #status = release
// #include = support/loadout.cs
// #include = support/callback.cs
// #credit = All credit goes to Monk and Fragbait i only combined their scripts into this one

if(!isObject(EgoAmmo))
{
	new ScriptObject(EgoAmmo)
	{
		class = EgoAmmo;
		
		hideInvHud = false;  // hide inventory hud always - set to false to display inventory hud
		hideWpnHud = false;  // hide weapons hud always - set to false to display weapons hud
		hidethirdperson = false; // hide ammohud when in 3rd person
	};
}
package EgoAmmoPackage
{
	function DispatchLaunchMode()
	{
		parent::DispatchLaunchMode();
		if(EgoAmmo.hideInvHud) playGui.remove(inventoryHud);
		if(EgoAmmo.hideWpnHud) playGui.remove(weaponsHud);
		EgoAmmo.create();
	}
	function PlayGui::onWake(%this)
	{
		parent::onWake(%this);
		EgoAmmoHud.setVisible(true);
		if(isObject(HudMover)) hudmover::addhud(EgoAmmoHud, "EgoAmmoHud");
	}
	function ammoHud::setValue(%slot, %amount)
	{
		parent::setValue(%slot, %amount);
		%ammoUpdate = "<color:ffffff>" @ %amount;
		$ammoUpdate = %ammoUpdate;
		EgoAmmoHudText.setText(%ammoUpdate@$kitUpdate);
	}
	function clientCmdSetInventoryHudAmount(%slot, %amount)
	{
		if(%slot == 0)
		{
			%grenades = %amount;
			if(loadout.GetGrenadeType() $= "Grenade") %grenadeUpdate = "<color:804000>" @ %grenades;
			else if(loadout.GetGrenadeType() $= "Whiteout Grenade") %grenadeUpdate = "<color:ffffff>" @ %grenades;
			else if(loadout.GetGrenadeType() $= "Concussion Grenade") %grenadeUpdate = "<color:4040ff>" @ %grenades;
			else if(loadout.GetGrenadeType() $= "Flare Grenade") %grenadeUpdate = "<color:ff0000>" @ %grenades;
			else if(loadout.GetGrenadeType() $= "Deployable Camera") %grenadeUpdate = "<color:000000>" @ %grenades;
			else %grenadeUpdate = "<color:00ff00>" @ %grenades;
			if (%grenades $="0") %grenadeUpdate = "";
			$grenadeUpdate = %grenadeUpdate;
			EgoGrenHudText.setText(%grenadeUpdate@" "@$minesUpdate);
		}
		else if(%slot == 3)
		{
			%kit = %amount;
			if(%kit > 0) %kitUpdate = "<color:00ff00>+";
			else %kitUpdate = "<color:ff0000>-";
			$kitupdate = %kitUpdate;
			EgoAmmoHudText.setText($ammoUpdate@%kitUpdate);
			
		}
		else if(%slot == 1)
		{
			%mines = %amount;
			%minesUpdate = "<color:00ff00>" @ %amount;
			if (%amount $= "0") %minesUpdate = "";
			$minesUpdate = %minesUpdate;
			EgoGrenHudText.setText($grenadeUpdate@" "@%minesUpdate);
		}
		parent::clientCmdSetInventoryHudAmount(%slot, %amount);
	}
	function ClientCmdDisplayHuds()
	{
		parent::ClientCmdDisplayHuds();
		ammoHud.setVisible(false);
		switch$ ($HudMode)
		{
			case "Pilot":
				EgoAmmoHud.setVisible(false);
			case "Passenger":
				EgoAmmoHud.setVisible(true);
			case "Object":
				EgoAmmoHud.setVisible(false);
			case "Observer":
				EgoAmmoHud.setVisible(false);
			case "Pick Team":
				EgoAmmoHud.setVisible(false);
			case "Standard":
				EgoAmmoHud.setVisible(true);
			default: 
				EgoAmmoHud.setVisible(false);
		}
	}
	function clientCmdToggleVehicleHuds() { 
		parent::clientCmdToggleVehicleHuds();
		AmmoHud.setVisible(false); 
	} 
	function clientcmdTogglePlayHuds(%val)
	{
		parent::clientcmdTogglePlayHuds(%val);
		ammoHud.setVisible(false);
		if(EgoAmmo.hideInvHud) inventoryHud.setVisible(false);
		if(EgoAmmo.hideWpnHud) weaponsHud.setVisible(false);
	}
	function hudFirstPersonToggled()
	{
		parent::hudFirstPersonToggled();
		if (EgoAmmo.HideThirdPerson) EgoAmmoHud.setVisible($firstPerson);
		ammoHud.setVisible(false);
		if(EgoAmmo.hideInvHud) inventoryHud.setVisible(false);
		if(EgoAmmo.hideWpnHud) weaponsHud.setVisible(false);
	}	
	function clientCmdSetWeaponsHudActive(%slot, %ret, %vis) {
		parent::clientCmdSetWeaponsHudActive(%slot, %ret, %vis);
		ammoHud.setVisible(false);
	}
	function EgoAmmo::create()
	{
		new GuiControlProfile("EgoAmmoHudProfile")
		{
			fontType = "Verdana";
			fontSize = 10;
			bitmap = "";
			fontColor = "0 0 0";
			justify = "center";
		};
		%xCenter = getword($pref::Video::resolution, 0) / 2;  // get screen center
		%x = %xCenter - 25;
		%y = 100;
		new ShellFieldCtrl("EgoAmmoHud")
		{
			profile = "GuiConsoleProfile";
			position = getword($pref::Video::resolution, 0)/2-40 @ " " @ getword($pref::Video::resolution, 1)/2+25;
			extent = "36 52";
			minExtent = "8 8";
			visible = "1";
			new GuiMLTextCtrl(EgoAmmoHudText)
			{
				profile = "EgoAmmoHudProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "3 3";
				extent = "33 12";
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				lineSpacing = "1";
				allowColorChars = "1";
				maxChars = "-1";
			};
			new GuiMLTextCtrl(EgoGrenHudText)
			{
				profile = "EgoAmmoHudProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "3 16";
				extent = "33 12";
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				lineSpacing = "1";
				allowColorChars = "1";
				maxChars = "-1";
			};
			new GuiMLTextCtrl(EgoKitHudText)
			{
				profile = "EgoAmmoHudProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "3 29";
				extent = "33 12";
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				lineSpacing = "1";
				allowColorChars = "1";
				maxChars = "-1";
			};			
		
		};		
		playgui.add(EgoAmmoHud);
	}
	function StartSelectedDemo()
	{
		EgoGrenHudText.setText("");
		EgoAmmoHudText.setText("");
		parent::StartSelectedDemo();
	}
	function demoPlaybackComplete()
	{
		EgoGrenHudText.setText("");
		EgoAmmoHudText.setText("");
		parent::demoPlaybackComplete();
	}
};
activatePackage(EgoAmmoPackage);
